#!/usr/bin/perl
#
# Graphics Muse Page Generator:  Blog registration 
#
# (c) 2002 Michael J. Hammel
#
#======================================================================

# Include the relevent perl modules
use CGI	qw/:standard :html3 :netscape/;
use Msql;
use POSIX;

require "globals.pl";
require "gettime.pl";

$PAGETITLE="Blog: ";
$WEBMASTER="webmaster";
$HTML_DIR="/home/httpd/blog/templates";
$HTML_DIR2="/home/httpd/blog";

# Grab the registration data.
$last = param('last');
$first = param('first');
$userid = param('userid');
$location = param('location');
$company = param('company');
$group = param('group');
$city = param('city');
$state = param('state');
$officephone = param('officephone');
$cellphone = param('cellphone');
$homephone = param('homephone');
$fax = param('fax');
$email = param('email');

#======================================================================
# Database stuff - we do this up front.
#
# Open the Msql connections and select the databases of interest.
my $dbh1 = Msql->connect();
$dbh1->selectdb($DATABASE);

# Grab a list of users to create side bar links
$query_line = "SELECT * FROM registrations order by first";
$sth = $dbh1->query($query_line);
while (@result = $sth->fetchrow)
{
	$name = join(" ", $result[3], $result[2]);
	push @userlist, 
			font({-size=>"-1"}, 
				a({-class=>"navbar", -href=>"/blog/userlogs.pl?id=$result[0]"}, 
					b("$name") 
				)
			),
			br();
	push @userids, $result[1];
}


# Must be done after the database has been opened and user list generated!
require "header-blog.pl";

#======================================================================
# Error check the registration data.
$error = 0;
$fullname = "";
$fulllocation = "";
if ( "$userid" eq "")
{
	push @reg_results, "You must supply a userid.", p();
	$error = 1;
}
if ( "$last" eq "")
{
	push @reg_results, "You must supply a last name.", p();
	$error = 1;
}
if ( "$first" eq "")
{
	push @reg_results, "You must supply a first name.", p();
	$error = 1;
}
if ( "$location" eq "")
{
	push @reg_results, "You must supply a location.", p();
	$error = 1;
}
if ( $error == 1 ) 
{
	push @reg_results, "User your BACK button to use another userid.";
	goto display_results;
}

# Users full name, location and email address.
$fullname = "$first $last";
$fulllocation = "($location)";

#======================================================================
# Check to see if userid is already in use.
$index=0;
$query_lines[$index++] = "SELECT * FROM registrations where userid = '";
$query_lines[$index++] = $userid;
$query_lines[$index++] = "'";
$query_line = join("", @query_lines);
undef @query_lines;
$sth = $dbh1->query($query_line);

# If the userid already exists, output a page that says so.
if ( $sth->numrows != 0 )
{
	@result=$sth->fetchrow;
	push @reg_results,
		"Userid ",
		b($userid),
		"is currently in use by ",
		$result[3], $result[2], "of", $result[5],
		p(),
		"User your BACK button to use another userid.";
	goto display_results;
}


#======================================================================
# User id doesn't exist.  Add it to the db.
#
# Get the next sequence number for the registrations table
$query_line = "SELECT _seq FROM registrations";
$sth1 = $dbh1->query($query_line);
@seq = $sth1->fetchrow;

# Build the SQL insert statement.
$index=0;
$query_lines[$index++] = "INSERT INTO registrations VALUES ( @seq, '";
$query_lines[$index++] = $userid;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $last;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $first;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $company;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $location;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $group;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $city;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $state;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $officephone;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $cellphone;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $homephone;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $fax;
$query_lines[$index++] = "', '";
$query_lines[$index++] = $email;
$query_lines[$index++] = "')";

$query_line = join("", @query_lines);
undef @query_lines;

# Add the new user to the db
$sth1 = $dbh1->query($query_line);

# Make sure it worked okay.
if ( length(Msql->errmsg) > 0 )
{
	push @reg_results, 
		"Registration Error (registrations.pl):",
		br(),
		"Failed insert into of $table table.",
		br(),
		"mSQL Error message: ", Msql->errmsg, 
		br();
	goto display_results;
}

$fullname = "$first $last";
push @reg_results,
	"Congratulations!  You're now registered to submit your logs",
	"to the $ORGANIZATION Blog.  Download the appropriate",
	a({-href=>"/download.html"}, "client software"), 
	"to begin submitting your logs.";


#======================================================================
# Write the HTML data back to the user.



# Display the results of the attempted registration
display_results:
setheader2($DOMAIN, "BLOG Registrations");

print 
	table( {-border=>"0", -width=>"100%",
		-cellpadding=>"2", -cellspacing=>"0", -nosave}, "\n",

		Tr({-valign=>"top"}, "\n",

			# The left-side navigation bar
			@navbar,

			td({-width=>"100%", -align=>"left"},

				# The content side.
				"<!-- The Content side -->\n",

				table( {-border=>"0", -bgcolor=>"#FFFFFF", -width=>"100%",
					-cellpadding=>"0", -cellspacing=>"0"},

					Tr(td(
						br({-clear=>"both"}),
						b(font({-size=>"+1"}, "BLOG:&nbsp; $fullname $fulllocation")),
						b(font({-size=>"+1"}, "&nbsp;&nbsp;&nbsp;")),
						br({-clear=>"both"}),
						"<hr NOSHADE WIDTH=\"100%\">",

						@reg_results

					))
			
				)
			)
		)
	);

setfooter(FD);

print end_html;

