#!/usr/bin/perl5
#
# Gather and return date information, in various formats.
#
# (c) 1999 Michael J. Hammel
#
#======================================================================
use CGI	qw/:standard :html3 :netscape/;
use Msql;

sub gettime
{
	my @arg = @_;

	my $sec;
	my $min;
	my $hour;
	my $mday;
	my $mon;
	my $year;
	my $wday;
	my $yday;
	my $isdist;
	my $datestring;

	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdist) = localtime(time);

	$datestring = $year + 1900;
	$datestring *= 10000;

	if ( "$arg[0]" ne "" )
	{
		if ( "$arg[0]" eq "month" )
		{
			$datestring = sprintf("%02d", $mon+1);
			return $datestring;
		}
		if ( "$arg[0]" eq "day" )
		{
			$datestring = sprintf("%02d", $mday);
			return $datestring;
		}
		return ($year + 1900);
	}

	$datestring += ($mon+1)*100 + $mday;
	return $datestring;
}

sub builddate
{
	my ($year, $month, $day) = @_;

	if ( $month < 10 )
	{
		$month = "0$month";
	}
	if ( $day < 10 )
	{
		$day = "0$day";
	}

	return "$year$month$day";
}

1
