#!/usr/bin/perl
#
# Graphics Muse Page Generator:  Blog user pages
#
# (c) 2002 Michael J. Hammel
#
#======================================================================

# Include the relevent perl modules
use CGI	qw/:standard :html3 :netscape/;
use Msql;
use POSIX;

require "globals.pl";
require "gettime.pl";

$PAGETITLE="Blog: ";
$WEBMASTER="webmaster";
$HTML_DIR="/home/httpd/blog/templates";
$HTML_DIR2="/home/httpd/blog";

# How many entries to display on any one page.
$setcount = 10;

$id = param('id');
if ( param('offset') )
{
	$offset = param('offset');
}
else
{
	$offset = 0;
}

#======================================================================
# Database stuff - we do this up front.
#
# Open the Msql connections and select the databases of interest.
my $dbh1 = Msql->connect();
$dbh1->selectdb($DATABASE);

# Grab a list of users to create side bar links
$query_line = "SELECT * FROM registrations order by first";
$sth = $dbh1->query($query_line);
while (@result = $sth->fetchrow)
{
	$name = join(" ", $result[3], $result[2]);
	push @userlist, 
			font({-size=>"-1"}, 
				a({-class=>"navbar", -href=>"/blog/userlogs.pl?id=$result[0]"}, 
					b("$name") 
				)
			),
			br();
	push @userids, $result[1];
}

# Must be done after the database has been opened and user list generated!
require "header-blog.pl";

# Grab a users logs
$query_line = "SELECT * FROM registrations where id = $id";
$sth = $dbh1->query($query_line);
@result = $sth->fetchrow;
$username = $result[1];
$fullname = "$result[3] $result[2]";
$location = "$result[5]";
$officephone = $result[9];
$cellphone = $result[10];
$homephone = $result[11];
if ( "$officephone" eq "" )
{
   $officephone = "N/A";
}
if ( "$cellphone" eq "" )
{
   $cellphone = "N/A";
}
if ( "$homephone" eq "" )
{
   $homephone = "N/A";
}
$fax = $result[10];
if ( "$fax" eq "" )
{
   $fax = "N/A";
}
$email = $result[11];
if ( "$email" eq "" )
{ 
   $email = "$username\@panasas.com";
}

$index=0;
$query_lines[$index++] = "SELECT * FROM logs where userid = '";
$query_lines[$index++] = "$username";
$query_lines[$index++] = "' order by id desc";
$query_line = join("", @query_lines);
$sth = $dbh1->query($query_line);
$totalentries = $sth->numrows;
$count = 0;
while (@result = $sth->fetchrow)
{
	if ( $count >= $offset )
	{
		# Read the log file for that entry.
		open(FD, "$HTML_DIR2/logs/$username/$result[4]");
		while (<FD>)
		{
			push @logfile, $_;
		}
		close(FD);
	
		# Post process it for the web page.
		$logdata = join("", @logfile);
		$logdata =~ s/\n\n/\n<p>\n/g;
		undef @logfile;
	
		# Save the users entry for the front page
		$userid = $result[1];
		$host = $result[2];
		$timestamp = $result[3];
	
		push @fplog_entries, 
			Tr( td(
				b("$userid\@$host &nbsp;&nbsp;"), $timestamp, br(), br(),
				"<blockquote>$logdata</blockquote>",
				hr({-noshade=>"0", -width=>"75%"}),
				br({-clear=>"both"})
			));
	}
	
	$count++;
	if ( $count > $offset )
	{
		if ( $count == ($offset + $setcount) )
		{
			last;
		}
	}
}

# Set the next offset
$offset = $offset + $setcount;
if ( $totalentries < $offset )
{
	push @nextopt, "";
}
else
{
	push @nextopt, 
					a({-href=>"/blog/userlogs.pl?id=$id&offset=$offset"}, 
						"Next $setcount entries"
					);
}


#======================================================================
# Write the HTML data back to the user.


	# Write out the new file.
	setheader2($DOMAIN, "$PAGETITLE $pgtitles[$index]");

	print 
		table( {-border=>"0", -width=>"100%",
			-cellpadding=>"2", -cellspacing=>"0", -nosave}, "\n",

			Tr({-valign=>"top"}, "\n",

				# The left-side navigation bar
				@navbar,

				td({-width=>"100%", -align=>"left"},

					# The content side.
					"<!-- The Content side -->\n",

					table( {-border=>"0", -bgcolor=>"#FFFFFF", -width=>"100%",
						-cellpadding=>"0", -cellspacing=>"0"},

                  Tr(td(
                     br({-clear=>"both"}),
                     b(font({-size=>"+1"}, "BLOG:&nbsp; $fullname ($location)")),
                     b(font({-size=>"+1"}, "&nbsp;&nbsp;&nbsp;")),
                     b(font({-size=>"-1"}, "@nextopt")),
                     br({-clear=>"both"}),
                     font({-size=>"-1"}, "Office: "),
                     b(font({-size=>"-1"}, "$Officephone &nbsp;/&nbsp; ")),
                     font({-size=>"-1"}, "Cell: "),
                     b(font({-size=>"-1"}, "$cellphone &nbsp;/&nbsp; ")),
                     font({-size=>"-1"}, "Home: "),
                     b(font({-size=>"-1"}, "$homephone &nbsp;/&nbsp; ")),
                     font({-size=>"-1"}, "FAX: "),
                     b(font({-size=>"-1"}, "$fax &nbsp;/&nbsp; ")),
                     font({-size=>"-1"}, "Email: "),
                     b(font({-size=>"-1"}, "$email")),
                     "<hr NOSHADE WIDTH=\"100%\">",

							@fplog_entries,

						))
				
					),

					# The offset into the db for the next page is set here.
					br(),
					@nextopt
				)
			)
		);

	setfooter(FD);

	print end_html;

